%define _missing_doc_files_terminate_build 0

Summary: Multi-platform Canvas Library
Name: evas
Version: 0.9.9.019
Release: 0.20050908
License: BSD
Group: System Environment/Libraries
URL: http://www.enlightenment.org/
Source: %{name}-%{version}.tar.gz
Packager: %{?_packager:%{_packager}}%{!?_packager:Michael Jennings <mej@eterm.org>}
Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:The Enlightenment Project (http://www.enlightenment.org/)}
Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}
#BuildSuggests: xorg-x11-devel freetype2-devel freetype-devel
BuildRequires: libpng-devel eet-devel edb-devel XFree86-devel libjpeg-devel
BuildRequires: /usr/bin/freetype-config
Provides: evas evas_software_x11 evas_loader_png evas_loader_jpeg evas_loader_eet evas_loader_edb
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
Evas is a clean display canvas API for several target display systems
that can draw anti-aliased text, smooth super and sub-sampled scaled
images, alpha-blend objects much and more.

%package devel
Summary: Evas headers, static libraries, documentation and test programs
Group: System Environment/Libraries
Requires: %{name} = %{version}
Requires: libpng-devel eet-devel edb-devel XFree86-devel libjpeg-devel
Requires: /usr/bin/freetype-config

%description devel
Headers, static libraries, test programs and documentation for Evas.

%prep
%setup -q -n %{name}-%{version}

%build
%{configure} --prefix=%{_prefix} --x-libraries=%{_prefix}/X11R6/%{_lib} $RPM_CONFIGURE_OPTS
%{__make} %{?_smp_mflags} %{?mflags}
test -x `which doxygen` && /bin/sh gendoc || :

%install
%{__make} %{?mflags_install} DESTDIR=$RPM_BUILD_ROOT install

%clean
test "x$RPM_BUILD_ROOT" != "x/" && rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%defattr(-, root, root)
%doc AUTHORS COPYING COPYING-PLAIN README
%{_libdir}/*.so.*
%{_libdir}/*.la
%{_bindir}/evas_*
%{_datadir}/%{name}

%files devel
%defattr(-, root, root)
%{_libdir}/*.so
%{_libdir}/*.a
%{_bindir}/evas-config
%{_libdir}/pkgconfig/*
%{_includedir}/*.h

%changelog
